<?php
/*
Plugin Name: WP-Popular Posts Tool
Plugin URI: http://teofiloisrael.com/plugin-popular-posts-tool/
Description: Enables you to automatically display most commented posts, either by category or tag. Optional: You can choose manually the category or tag you want to display its most commented posts. It has a widget to add it easily to your sidebar. See this plugin in action in http://teofiloisrael.com
Author: Teofilo Israel Vizcaino Rodriguez
Version: 2.0
Author URI: http://teofiloisrael.com
Demo URI: http://teofiloisrael.com
*/ 
 
class WpPopularPostsTool extends WP_Widget {
    
    function WpPopularPostsTool() {
        //Constructor
        $widget_ops = array('classname' => 'WpPopularPostsTool', 'description' => __('Automatically display most commented posts, either by category or tag, or manually choose the category or tag to display its most commented posts'));
        $this->WP_Widget('WpPopularPostsTool', 'WP-Popular Posts Tool', $widget_ops);
    }
    
    /**
     * Prints the list of popular posts
     */
	function ti_popular_posts($num, $my_id=0, $begin='<ul>', $end='</ul>', $pre='<li>', $suf='</li>'){
        global $wpdb;
        if($my_id==0):
            if(is_category()): 
                $my_title = strtolower(single_cat_title('', false));  $my_id = get_cat_ID($my_title); 
            elseif(is_tag()):
                $my_title = $my_id = intval(get_query_var('tag_id'));
            elseif(is_single()):
                $my_title = get_the_category(); $my_id = $my_title[0]->cat_ID;
            endif;
        endif;
        if(!is_category() && !is_tag() && !is_single() && $my_id==0): 
            $querystr = "SELECT $wpdb->posts.post_title, $wpdb->posts.ID, $wpdb->posts.post_content, $wpdb->posts.comment_count FROM $wpdb->posts WHERE $wpdb->posts.post_status = 'publish' AND $wpdb->posts.post_type = 'post' ORDER BY $wpdb->posts.comment_count DESC LIMIT $num";
        else:
            $querystr = "SELECT $wpdb->posts.post_title, $wpdb->posts.ID, $wpdb->posts.post_content, $wpdb->posts.comment_count FROM $wpdb->posts INNER JOIN $wpdb->term_relationships ON ($wpdb->posts.ID = $wpdb->term_relationships.object_id) INNER JOIN $wpdb->term_taxonomy ON ($wpdb->term_relationships.term_taxonomy_id = $wpdb->term_taxonomy.term_taxonomy_id) WHERE term_id=$my_id AND $wpdb->posts.post_status = 'publish' AND $wpdb->posts.post_type = 'post' ORDER BY comment_count desc LIMIT $num";
        endif;	

        $myposts = $wpdb->get_results($querystr, OBJECT);
        echo $begin;
        foreach($myposts as $post) {
            echo $pre;
            ?><a href="<?php echo get_permalink($post->ID); ?>"><?php echo $post->post_title ?></a><?php
            echo '<br />' . $post->comment_count . ' '; _e('comments'); 
            echo $suf;
        } echo '<li><small style="color:#666666; font-size:9px;"><a style="color:#666666; font-size:9px;" href="http://teofiloisrael.com/plugin-popular-posts-tool/">Popular posts Tool</a> for Wordpress by <a style="color:#666666; font-size:9px;" href="http://teofiloisrael.com/">Teofilo Israel</a></small></li>';
        echo $end;
    }
    
	/**
	 * Prints widget for user
	 */    
    function widget($args, $instance) {
        extract($args, EXTR_SKIP);
    
        $itemsNumber = $instance['itemsQuantity'];
        $catId = $instance['catId'];
    
        $title = apply_filters('widget_title', $instance['title']);
     
        $widget_id = $args['widget_id'];
      
        do_action( 'TB_RenderWidget', $before_widget,$after_widget,$title,$itemsNumber,$catId);
  
    }
    
    function render($before_widget,$after_widget,$title,$itemsNumber,$catId){
        echo $before_widget;
      
        if ( !empty( $title ) ) { 
            echo $before_title . $title . $after_title; 
        };

       WpPopularPostsTool::ti_popular_posts($itemsNumber, $catId);
        
       echo $after_widget;
    }
    
    /**
     * Saves the widget
     */
    function update($new_instance, $old_instance) {
        $instance = $old_instance;
        $instance['title'] = strip_tags($new_instance['title']);
        $instance['itemsQuantity'] = absint(strip_tags($new_instance['itemsQuantity'])); 
        $instance['catId'] = absint(strip_tags($new_instance['catId']));
        
        return $instance;
    }
    
    /**
     * Widget form for backend
     */
    function form($instance) {
        $instance = wp_parse_args( (array) $instance, array( 'title' => 'WP-Popular Posts Tool', 'itemsQuantity' => 5, 'catId' => 0 ) );
        $title = strip_tags($instance['title']);
        $itemsQuantity = absint($instance['itemsQuantity']);
        $catId = absint($instance['catId']);
    ?>
    <p><label for="<?php echo $this->get_field_id('title'); ?>"><?php echo esc_html__('Title'); ?>: <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo attribute_escape($title); ?>" /></label></p>
    <p><label for="<?php echo $this->get_field_id('itemsQuantity'); ?>"><?php echo esc_html__('Number of items to show:'); ?>: <input class="widefat" id="<?php echo $this->get_field_id('itemsQuantity'); ?>" name="<?php echo $this->get_field_name('itemsQuantity'); ?>" type="text" value="<?php echo attribute_escape($itemsQuantity); ?>" /></label></p>  
    <p><label for="<?php echo $this->get_field_id('catId'); ?>"><?php echo esc_html__('Id of the cateogory or tag (leave it blank for automatic detection):'); ?>: <input class="widefat" id="<?php echo $this->get_field_id('catId'); ?>" name="<?php echo $this->get_field_name('catId'); ?>" type="text" value="<?php echo attribute_escape($catId); ?>" /></label></p><?php
    }
}

/**
 * Use this function if you want to use the plugin directly from the code
 */
function ti_popular_posts($num, $my_id=0, $begin='<ul>', $end='</ul>', $pre='<li>', $suf='</li>'){
    WpPopularPostsTool::ti_popular_posts($num, $my_id, $begin, $end, $pre, $suf);
}
   
add_action( 'widgets_init', create_function('', 'return register_widget("WpPopularPostsTool");') );
add_action( 'TB_RenderWidget', array('WpPopularPostsTool', 'render'),10,12 );   

?>